widget_mgabolanimav/announcements/urls.py
from django.urls import path
from .views import Announcements, AnnouncementsDetailsView, AnnouncementsCreateView, AnnouncementsEditView

urlpatterns = [
   path('', Announcements, name="announcements"),
   path('<int:pk>/details/', AnnouncementsDetailsView.as_view(), name="announcement-details"),
   path('add/', AnnouncementsCreateView.as_view(), name="announcement-add"),
   path('<int:pk>/edit/', AnnouncementsEditView.as_view(), name="announcement-edit"),
]

app_name = 'announcements'

widget_mgabolanimav/dashboard/urls.py
from django.urls import path

from . import views
from .views import (
    WidgetUserDetailsView, WidgetUserCreateView, WidgetUserUpdateView
)

urlpatterns = [
    path('dashboard/', views.dashboard, name = "dashboard"),
    path('widgetusers/<int:pk>/details/', WidgetUserDetailsView.as_view(), name = "widgetuser-detail"),
    path('widgetusers/add/', WidgetUserCreateView.as_view(), name = "widgetuser-add"),
    path('widgetusers/<int:pk>/edit/', WidgetUserUpdateView.as_view(), name = "widgetuser-edit"),
]

app_name = 'dashboard'

widget_mgabolanimav/forum/urls.py
from django.urls import path
from.views import Forum, ForumDetailViews, ForumCreateView, ForumEditView

urlpatterns = [
   path('', Forum, name="forum"),
   path('<int:pk>/details/', ForumDetailViews.as_view(), name="forumpost-details"),
   path('add/', ForumCreateView.as_view(), name="forumpost-add"),
   path('<int:pk>/edit/', ForumEditView.as_view(), name="forumpost-edit"),
]

app_name = 'forum'

widget_mgabolanimav/widget_mgabolanimav/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include("dashboard.urls")),
    path('admin/', admin.site.urls),
    path('announcements/', include("announcements.urls")),
    path('forum/', include("forum.urls"))
]

widget_mgabolanimav/announcements/models.py
from django.db import models
from dashboard.models import WidgetUser
from django.urls import reverse
from django.utils import timezone


# Create your models here.

# please insert foreign key from dashboard application on announcement_author
class Announcement(models.Model):
    announcement_title = models.CharField(max_length=50, unique=True, null=True, verbose_name="Title")
    announcement_body = models.TextField(max_length=250, unique=True, null=True, verbose_name="Body")
    announcement_author = models.ForeignKey(WidgetUser, on_delete=models.CASCADE, null=True, verbose_name="Author")
    announcement_pub_datetime = models.DateTimeField(null=True, )

    def __str__(self):
        return self.announcement_title

    def save(self, *args, **kwargs):
        if not self.pk:
            self.announcement_pub_datetime = timezone.now()
        return super().save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('announcements:announcement-details', kwargs={'pk': self.pk})


reaction_choices = (
    ('Like', 'Like'),
    ('Love', 'Love'),
    ('Angry', 'Angry'),
)


class Reaction(models.Model):
    reaction_name = models.CharField(max_length=50, blank=True, choices=reaction_choices, null=True, )
    reaction_tally = models.IntegerField(null=True, default=0, )
    reaction_announcement = models.ForeignKey(Announcement, on_delete=models.CASCADE, null=True, )

    def __str__(self):
        return self.reaction_name

widget_mgabolanimav/dashboard/models.py
from django.db import models
from django.urls import reverse

# Create your models here.

class Department(models.Model):
    dept_name = models.CharField(max_length=50, unique=True, null=True)
    home_unit = models.CharField(max_length=50, null=True)

    def __str__(self):
        return self.dept_name

class WidgetUser(models.Model):
    first_name = models.CharField(max_length=30, unique=True, null=True)
    middle_name = models.CharField(max_length=20, unique=True, null=True)
    last_name = models.CharField(max_length=20, unique=True, null=True)
    user_department = models.ForeignKey(Department, on_delete=models.CASCADE)

    def __str__(self):
        return self.first_name
    
    def get_absolute_url(self):
        return reverse('dashboard:widgetuser-detail', kwargs={'pk': self.pk})

widget_mgabolanimav/forum/models.py
from django.db import models
from dashboard.models import WidgetUser
from django.urls import reverse
from django.utils import timezone

# Create your models here.

class ForumPost(models.Model):
    title = models.CharField(max_length = 50, unique = True, default = "", null = True,)
    body = models.TextField(default = "", null = True,)
    author = models.ForeignKey (WidgetUser, on_delete = models.CASCADE, default = "", null = True,)
    pub_datetime = models.DateTimeField(null = True,)

    def __str__(self):
        return self.title

    def save(self, *args, **kwargs):
        if not self.pk:
            self.pub_datetime = timezone.now()
        return super().save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('forum:forumpost-details', kwargs={'pk': self.pk})



class Reply(models.Model):
    body = models.TextField(default = "", null = True,)
    author = models.ForeignKey(WidgetUser, on_delete = models.CASCADE, default = "", null = True,)
    pub_datetime = models.DateTimeField(null = True,)
    forum_post = models.ForeignKey(ForumPost, on_delete = models.CASCADE, null = True,)

widget_mgabolanimav/announcements/views.py
from django.shortcuts import render
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import Announcement, Reaction


# Create your views here.
def Announcements(request):
    announcements = Announcement.objects.order_by("-announcement_pub_datetime")
    context = {
        "announcements": announcements,
    }

    return render(request, 'announcements/announcements.html', context)


class AnnouncementsDetailsView(DetailView):
    model = Announcement
    template_name = 'announcements/announcement-details.html'\


    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['reactions'] = Reaction.objects.filter(reaction_announcement=self.object)
        return context


class AnnouncementsCreateView(CreateView):
    model = Announcement
    fields = 'announcement_title', 'announcement_body', 'announcement_author'
    template_name = 'announcements/announcement-add.html'


class AnnouncementsEditView(UpdateView):
    model = Announcement
    fields = 'announcement_title', 'announcement_body', 'announcement_author'
    template_name = 'announcements/announcement-edit.html'

widget_mgabolanimav/dashboard/views.py
from .models import WidgetUser

from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

# Create your views here.
def dashboard(request): 
    widget_users = WidgetUser.objects.all()
    context = {"widget_users": widget_users}
    return render(request, 'dashboard/dashboard.html', context)

class WidgetUserDetailsView(DetailView):
    model = WidgetUser
    template_name = 'dashboard/widgetuser-details.html'

class WidgetUserCreateView(CreateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-add.html'

class WidgetUserUpdateView(UpdateView):
    model = WidgetUser
    fields = '__all__'
    template_name = 'dashboard/widgetuser-edit.html'

widget_mgabolanimav/forum/views.py
from .models import ForumPost, Reply
from django.http import HttpResponse
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView
from django.shortcuts import render

# Create your views here.

def Forum(request):
    forums = ForumPost.objects.order_by("-pub_datetime")
    context = {
        "forums": forums,
    }

    return render(request, 'forum/forum.html', context)


class ForumDetailViews(DetailView):
    model = ForumPost
    template_name = 'forum/forumpost-details.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['replies'] = Reply.objects.filter(forum_post=self.object)
        return context
    
class ForumCreateView(CreateView):
    model = ForumPost
    fields = 'title', 'body', 'author'
    template_name = 'forum/forumpost-add.html'

class ForumEditView(UpdateView):
    model = ForumPost
    fields = 'title', 'body', 'author'
    template_name = 'forum/forumpost-edit.html'

widget_mgabolanimav/announcements/templates/announcements/announcement-add.html
{% extends 'base.html' %}
{% block title %} Add Announcement {% endblock %}
{% block content %}
    <h1> Add a new announcement</h1>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="Submit" value="Add Announcement">
    </form>
{% endblock %}

widget_mgabolanimav/announcements/templates/announcements/announcement-details.html
{% extends 'base.html' %}
{% block title %}{{ announcement.announcement_title }}{% endblock %}
{% block content %}
    <h1>{{ announcement.announcement_title }} <br>
    by {{ announcement.announcement_author.first_name }}
        {{ announcement.announcement_author.last_name }}
    </h1>
    {{ announcement.announcement_pub_datetime }} <br>
    {{ announcement.announcement_body }} <br>
    {% for reaction in reactions %}
        <p>{{ reaction.reaction_name }}: {{ reaction.reaction_tally }}</p>
    {% endfor %} <br>


    <a href="{% url 'announcements:announcement-edit' pk=announcement.pk %}">
            <button>Edit Announcement</button>
    </a>

{% endblock %}

widget_mgabolanimav/announcements/templates/announcements/announcement-edit.html
{% extends 'base.html' %}
{% block title %} Edit Announcement {% endblock %}
{% block content %}
    <h1> Edit announcement:</h1>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="Submit" value="Save Changes">
    </form>
{% endblock %}

widget_mgabolanimav/announcements/templates/announcements/announcements.html
{% extends 'base.html' %}
{% block title %} Widget's Announcement Board {% endblock %}
{% block content %}
        <h1>Welcome to Widget's Announcement Board!</h1>
        <h3>Announcements:</h3>
        {% for announcement in announcements %}
            <a href="{% url 'announcements:announcement-details' announcement.id %}"> {{ announcement.announcement_title }}
                by {{ announcement.announcement_author.first_name }} {{ announcement.announcement_author.last_name }}
            </a> <br>
        {% endfor %} <br>

        <a href="{% url 'announcements:announcement-add' %}">
            <button>New Announcement</button>
        </a> <br><br>

        <a href="{% url 'dashboard:dashboard' %}">Dashboard</a> <br>
        <a href="{% url 'forum:forum' %}">Forum</a> <br>

{% endblock %}

widget_mgabolanimav/dashboard/templates/dashboard/dashboard.html
{% extends 'base.html' %}
{% block title %}Widget v2{% endblock %}
{% block content %}
        <h1>Welcome to Widget!</h1>
        <h2>Widget Users:</h2>
        {% for user in widget_users %}
        <a href="{% url 'dashboard:widgetuser-detail' user.id %}">
            {{user.last_name}}, {{user.first_name}}
        </a><br>
        {% endfor %}
        <br>
        <a href="{% url 'dashboard:widgetuser-add' %}">
            <button>Add Widget User</button>
        </a>
        <br><br>
        <a href="{% url 'announcements:announcements' %}">Announcement Board</a> <br>
        <a href="{% url 'forum:forum' %}">Forum</a>
{% endblock %}

widget_mgabolanimav/dashboard/templates/dashboard/widgetuser-add.html
{% extends 'base.html' %}
{% block title %}Add Widget User{% endblock %}
{% block content %}
    <h2>Add a new Widget user:</h2>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="Submit" value="Add Widget User">
    </form>
{% endblock %}

widget_mgabolanimav/dashboard/templates/dashboard/widgetuser-details.html
{% extends 'base.html' %}
{% block title %}{{ object.last_name }}, {{ object.first_name }}{% endblock %}
{% block content %}
        <h1>{{ object.first_name }} {{object.middle_name}} {{ object.last_name }}</h1>
        <p>
            {{ object.user_department.dept_name }}<br>
            {{ object.user_department.home_unit }}
        </p>
        <a href="{% url 'dashboard:widgetuser-edit' object.id %}">
            <button>Edit Widget User</button>
        </a>
{% endblock %}

widget_mgabolanimav/dashboard/templates/dashboard/widgetuser-edit.html
{% extends 'base.html' %}
{% block title %}Edit Widget User{% endblock %}
{% block content %}
    <h2>Edit Widget User:</h2>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="Submit" value="Save Changes to Widget User">
    </form>
{% endblock %}

widget_mgabolanimav/forum/templates/forum/forum.html
{% extends 'base.html' %}
{% block title %} Widget's Forum {% endblock %}
{% block content %}
        <h1>Welcome to Widget's Forum!</h1>
        <h3>Forum Posts:</h3>
        {% for forum in forums %}
            <a href="{% url 'forum:forumpost-details' forum.id %}"> {{ forum.title }}
                by {{ forum.author.first_name }} {{ forum.author.last_name }}
            </a> <br>
        {% endfor %} <br>

        <a href="{% url 'forum:forumpost-add' %}">
            <button>New Post</button>
        </a> <br><br>

        <a href="{% url 'dashboard:dashboard' %}">Dashboard</a> <br>
        <a href="{% url 'announcements:announcements' %}">Announcement Board</a> <br>

{% endblock %}

widget_mgabolanimav/forum/templates/forum/forumpost-add.html
{% extends 'base.html' %}
{% block title %} Add Post {% endblock %}
{% block content %}
    <h1> Add a new post</h1>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="Submit" value="Add Post">
    </form>
{% endblock %}

widget_mgabolanimav/forum/templates/forum/forumpost-details.html
{% extends 'base.html' %}
{% block title %}{{ forumpost.title }}{% endblock %}
{% block content %}
    <h1>{{ forumpost.title }} <br>
    by {{ forumpost.author.first_name }}
        {{ forumpost.author.last_name }}
    </h1>
    {{ forumpost.pub_datetime }} <br>
    {{ forumpost.body }} <br> <br>

    Post Replies: <br>
    {% for reply in replies %}
        <br> by {{ reply.author.first_name }}
            {{ reply.author.last_name }}
        {{ reply.pub_datetime }} <br>
        {{ reply.body }} <br>
    {% endfor %} <br>

    <a href="{% url 'forum:forumpost-edit' object.id %}">
        <button>Edit Post</button>
    </a>


{% endblock %}

widget_mgabolanimav/forum/templates/forum/forumpost-edit.html
{% extends 'base.html' %}
{% block title %} Edit Post {% endblock %}
{% block content %}
    <h1> Edit post:</h1>
    <form method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="Submit" value="Save Changes">
    </form>
{% endblock %}

widget_mgabolanimav/templates/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <link rel="stylesheet" href="style.css">
        <title>{% block title %}{% endblock %}</title>
        {% block styles %}{% endblock %}
    </head>
    <body>
        <div id="content">
                {% block content %}{% endblock%}
        </div>
        {% block scripts%}{% endblock%}
    </body>  
</html>